<!DOCTYPE html>
<html>
{% load static %}
<head>
    <title>Fufu</title>
    <link rel="icon" href="{% static 'icon.png'%}" type="icon">
    <link rel="stylesheet" href="https://www.w3schools.com/w3css/4/w3.css">
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.1.3/css/bootstrap.min.css" integrity="sha384-MCw98/SFnGE8fJT3GXwEOngsV7Zt27NXFoaoApmYm81iuXoPkFOJwJ8ERdknLPMO" crossorigin="anonymous">
    <script src="https://code.jquery.com/jquery-3.6.0.js" integrity="sha256-H+K7U5CnXl1h5ywQfKtSj8PCmoN9aaq30gDh27Xc0jk=" crossorigin="anonymous"></script>

    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    {% include 'navbarFufu.html' %}
    <style>
        body {
            margin: 0;
            padding: 0;
            overflow-x: hidden;
            background-image: url('/static/pattern-randomized.svg');
        }
        body .slider-container{
            display: block;
            place-items: center;
        }
        * {
			font-family: 'Sora', sans-serif;
		}
        .fufu-title-container{
            width: 100%;
            margin-top: 200px;
            margin-left: 50px;
            float: left;
        }
        h1 {
            font-weight: bold;
            cursor:default;
        }
        .fufu-subtitle-container{
            margin-top: 0px;
            margin-left: 100px;
        }
        h4 {
            font-style: italic;
            cursor:default;
        }
        .see-all-container {
            margin-top: 0px;
            margin-right: 130px;
            float: right;
            cursor: pointer;
        }
        .see-all-button {
            text-decoration: none;
            color: #7e7e7e;
            font-size: larger;
        }
        .see-all-button:hover {
            color: #505050;
        }
        .modal {
            display: none;
            position: fixed;
            z-index: 1;
            padding-top: 100px;
            left: 0;
            top: 0;
            width: 100%;
            height: 100%;
            overflow-y:auto;
            background-color: rgba(0,0,0,0.4);
        }
        .modal-content {
            position: relative;
            background-color: #fefefe;
            margin: auto;
            padding: 0;
            border: 1px solid #888;
            width: 60%;
            box-shadow: 0 4px 8px 0 rgba(0,0,0,0.2),0 6px 20px 0 rgba(0,0,0,0.19);
            -webkit-box-shadow: 0 4px 8px 0 rgba(0,0,0,0.2),0 6px 20px 0 rgba(0,0,0,0.19);
            -webkit-animation-name: animatetop;
            -webkit-animation-duration: 0.4s;
            animation-name: animatetop;
            animation-duration: 0.4s;
        }

        /* Add Animation */
        @-webkit-keyframes animatetop {
            from {top:-300px; opacity:0}
            to {top:0; opacity:1}
        }

        @keyframes animatetop {
            from {top:-300px; opacity:0}
            to {top:0; opacity:1}
        }

        /* The Close Button */
        .close {
            color: rgb(0, 0, 0);
            float: right;
            font-size: 28px;
            font-weight: bold;
        }
        .close:hover,
        .close:focus {
            color: rgb(78, 78, 78);
            text-decoration: none;
            cursor: pointer;
        }
        .fufu-list{
            display: inline-grid;
            grid-template-columns: auto auto auto auto;
            grid-row-gap: 30px;
            padding-top: 50px;
            padding-left: 50px;
            padding-bottom: 50px;
            overflow-wrap: break-word;
        }
        .slider-container {
            height: 310px;
            width: 100%;
            display: grid;
            place-items: center;
            margin: 0px;
        }
        .slider {
            height: 310px;
            margin-left: 50px;
            position: relative;
            width: 1782px;
            display: grid;
            place-items: baseline;
            padding-top: 20px;
            overflow: hidden;
        }
        .slide-track {
            display: flex;
            width: fit-content;
            margin-left: 30px;
        }
        .slide-track:hover {
            animation-play-state: paused;
        }
        .fufu-slide{
            display: none;
        }
        .from-container {
            width: 149px;
            height: 20px;

            font-style: normal;
            font-weight: bold;
            font-size: 14px;
            line-height: 16px;

            letter-spacing: 0.75px;
            cursor: default;
        }
        .message-container {
            width: 169px;
            height: 152px;

            font-style: normal;
            font-weight: normal;
            font-size: 14px;
            line-height: 16px;

            letter-spacing: 0.75px;
            cursor: default;
        }
        .fufu_card {
			width: 200px;
            height: 260px;
			margin: 0px 20px;
			background: #f4f4f4;
			position: relative;
			display: flex;
			justify-content: center;
			flex-direction: column;
			padding: 15px;
			border-radius: 5px;
            align-items: center;
            overflow-wrap: break-word;
            transition: transform 0.1s;
            border-color: black;
            border-style: solid;
		}
        .fufu_card:hover {
			box-shadow: 10px 5px 5px #308a7e;
            transform: scale(1.1);
		}
        .no-fufu-slide {
            margin-top: 50px;
            text-align: center;
        }
        .no-fufu {
            color: #a1a1a1;
            width: 100%;
            cursor: default;
        }
        .no-fufu-msg {
            color: #a1a1a1;
            width: 100%;
            font-style: normal;
            cursor: default;
        }
        .btn-circle.btn-xl {
            width: 70px;
            height: 70px;
            padding: 0px 0px;
            border-radius: 35px;
            font-size: 50px;
            line-height: 1.33;
        }
        .btn-circle {
            width: 30px;
            height: 30px;
            padding: 6px 0px;
            border-radius: 15px;
            text-align: center;
            font-size: 12px;
            line-height: 1.42857;

        }
        .btn {
            background-color: #41B3A3;
            color: #f4f4f4;
            filter: drop-shadow(-2px 4px 6px rgba(0, 0, 0, 0.39));
            border: 0px;
        }
        .btn:hover {
            background-color: #308a7e;
            color: #f4f4f4;
        }
        .add-button-container {
            margin-top: 50px;
            margin-right: 190px;
            margin-bottom: 60px;
            float: right;
        }
    </style>
</head>
<body onload="callCarousel()">
<div class="fufu-title-container">
    <h1>From Us For Us (FUFU)</h1>
</div>
<div class="fufu-subtitle-container">
    <h4>A simple message to cheerish each other during pandemic</h4>
</div>
{% if groupedFufu|length > 0 %}
<div class="see-all-container">
    <a class="see-all-button" id="myBtn">see all</a>
</div>
{% endif %}
<div class=slider-container>
    {% if groupedFufu|length > 0 %}
    <div class="slider">
        <div class="slide-track" onmouseover="pauseCarousel()" onmouseout="continueCarousel()">
            {% for group in groupedFufu %}
            <div class="fufu-slide w3-animate-right">
                {% for fufu in group %}
                <div class="fufu_card">
                    <div class= "from-container">
                        <t>From: {{fufu.From}}</t>
                    </div><br>
                    <div class= "message-container">
                        {{fufu.Message}}
                    </div>
                </div>
                {% endfor %}
            </div>
            {% endfor %}
        </div>
    </div>
    {% else %}
    <div class="slider" style="place-items: center">
        <div class="slide-track">
            <div class="no-fufu-slide w3-animate-right">
                <h2 class="no-fufu">There is no FUFU to display</h2>
                <h4 class="no-fufu-msg">added fufu will show up here</h4>
            </div>
        </div>
    </div>
    {% endif %}
</div>
<div id="myModal" class="modal">
    <!-- Modal content -->
    <div class="modal-content">
        <div class="modal-body">
            <span class="close">&times;</span>
            <div class="fufu-list">
                {% for fufu in fufus %}
                <div class="fufu_card">
                    <div class= "from-container">
                        <t>From: {{fufu.From}}</t>
                    </div><br>
                    <div class= "message-container">
                        {{fufu.Message}}
                    </div>
                </div>
                {% endfor %}
            </div>
        </div>
    </div>
</div>
<script>
        var index = 0;
        var x = document.getElementsByClassName("fufu-slide");
        let func;
        function carousel() {
            if (x.length == 1) {
                x[0].style.display = "flex"
                return
            }
            for (var i = 0; i < x.length; i++) {
                x[i].style.display = "none";
            }
            index++;
            if (index > x.length) {
                index = 1
            }
            x[index-1].style.display = "flex";
        }

        // carousel driver
        function callCarousel() {
            if (x.length > 1) {
                carousel()
                func = setInterval(carousel, 5000) // call carousel every 5 seconds (wait 5 seconds first before the first call)
            }
            else if (x.length == 1) {
                carousel()
            }
            // dont call carousel if there's no fufu
            else {
                return
            }
        }

        // carousel pause
        function pauseCarousel() {
            if (x.length == 1) {
                return
            }
            else {
                clearInterval(func)
            }
        }

        // carousel continue
        function continueCarousel() {
            if (x.length == 1) {
                return
            }
            else {
                func = setInterval(carousel, 5000)
            }
        }

        // Get the modal
        var modal = document.getElementById("myModal");
        // Get the button that opens the modal
        var btn = document.getElementById("myBtn");
        // Get the <span> element that closes the modal
        var span = document.getElementsByClassName("close")[0];
        // When the user clicks the button, open the modal, button is not rendered if there's no fufu
        if (btn != null) {
            btn.onclick = function() {
                modal.style.display = "block";
                pauseCarousel();
            }
        }
        // When the user clicks on <span> (x), close the modal
        span.onclick = function() {
            modal.style.display = "none";
            continueCarousel()
        }
        // When the user clicks anywhere outside of the modal, close it
        window.onclick = function(event) {
        if (event.target == modal) {
            modal.style.display = "none";
            continueCarousel()
        }
        }
        $(document).on('click', '#myBtn', function(){
            $.ajax({
                method: "GET",
                url: "../fufuJson/"
            })
            .done(function( fufus ) {
                $(".fufu-list").empty();
                for (let i = 0; i < fufus.length; i++) {
                    $( ".fufu-list" ).append(
                        `
                        <div class="fufu_card">
                            <div class= "from-container">
                                <t>From: ${fufus[i].fields.From}</t>
                            </div><br>
                            <div class= "message-container">
                                ${fufus[i].fields.Message}
                            </div>
                        </div>
                        `
                    );
                }
            });
        });
        </script>
<div class = "add-button-container panel-body">
    <button type="button" class="btn btn-default btn-circle btn-xl" onclick="location.href='/add/'">+</button>
</div>
</body>
</html>
